export declare enum DependencyErrorType {
    SingletonScoped = 0,
    Circular = 1,
    Existence = 2,
    Duplicate = 3,
    Unknown = 4,
    MultiError = 5
}
export declare type ErrorTypes = {
    type: DependencyErrorType.Unknown | DependencyErrorType.Existence | DependencyErrorType.Duplicate;
    lifetime: string;
    message: string;
    cause: undefined;
} | {
    type: DependencyErrorType.Circular | DependencyErrorType.SingletonScoped;
    lifetime: string;
    cause: string;
    message: string;
} | {
    type: DependencyErrorType.MultiError;
    errors: (ErrorTypes | Error)[];
    message: string;
};
