"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Scoped = void 0;
var SingletonScopedDependencyError_1 = require("../Errors/SingletonScopedDependencyError");
var CircularDependencyError_1 = require("../Errors/CircularDependencyError");
var Scoped = /** @class */ (function () {
    function Scoped(name, factory) {
        Object.defineProperty(this, "name", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        Object.defineProperty(this, "factory", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        this.name = name;
        this.factory = factory;
    }
    Object.defineProperty(Scoped.prototype, "provide", {
        enumerable: false,
        configurable: true,
        writable: true,
        value: function (provider) {
            var _a = provider._, _b = _a.validation, trail = _b.trail, lastSingleton = _b.lastSingleton, scope = _a.scope;
            // If already provided, simply  return old instance
            if (scope[this.name])
                return scope[this.name];
            // Handle errors
            if (lastSingleton)
                throw new SingletonScopedDependencyError_1.SingletonScopedDependencyError(lastSingleton, this.name);
            if (trail[this.name])
                throw new CircularDependencyError_1.CircularDependencyError(this.name, this.name);
            // Pre-calling factory
            trail[this.name] = true;
            // Calling factory
            var value = this.factory(provider);
            // Post-calling factory
            delete trail[this.name];
            return (scope[this.name] = value);
        }
    });
    return Scoped;
}());
exports.Scoped = Scoped;
