"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Singleton = void 0;
var CircularDependencyError_1 = require("../Errors/CircularDependencyError");
var Singleton = /** @class */ (function () {
    function Singleton(name, factory) {
        Object.defineProperty(this, "name", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        Object.defineProperty(this, "factory", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        Object.defineProperty(this, "value", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        this.name = name;
        this.factory = factory;
    }
    Object.defineProperty(Singleton.prototype, "provide", {
        enumerable: false,
        configurable: true,
        writable: true,
        value: function (provider) {
            // If already provided, simply  return old instance
            if (this.value)
                return this.value;
            var validation = provider._.validation;
            // Handle errors
            if (validation.trail[this.name])
                throw new CircularDependencyError_1.CircularDependencyError(this.name, this.name);
            // Pre-calling factory
            var old = validation.lastSingleton;
            validation.lastSingleton = this.name;
            validation.trail[this.name] = true;
            // Calling factory
            var value = this.factory(provider);
            // Post calling factory
            validation.lastSingleton = old;
            delete validation.trail[this.name];
            return (this.value = value);
        }
    });
    return Singleton;
}());
exports.Singleton = Singleton;
