"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Transient = void 0;
var CircularDependencyError_1 = require("../Errors/CircularDependencyError");
var Transient = /** @class */ (function () {
    function Transient(name, factory) {
        Object.defineProperty(this, "name", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        Object.defineProperty(this, "factory", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        this.name = name;
        this.factory = factory;
    }
    Object.defineProperty(Transient.prototype, "provide", {
        enumerable: false,
        configurable: true,
        writable: true,
        value: function (provider) {
            var trail = provider._.validation.trail;
            // Handle errors
            if (trail[this.name])
                throw new CircularDependencyError_1.CircularDependencyError(this.name, this.name);
            // Pre-calling factory
            trail[this.name] = true;
            // Calling factory
            var value = this.factory(provider);
            // Post-calling factory
            delete trail[this.name];
            return value;
        }
    });
    return Transient;
}());
exports.Transient = Transient;
