import { NameSelector, ProviderFactory, ProviderScope, ProviderValidation } from './types';
import { IServiceCollection } from './ServiceCollection/IServiceCollection';
export declare type ProviderContext<E> = {
    services: IServiceCollection<E>;
    create: ProviderFactory<E>;
    validation: ProviderValidation;
    scope: ProviderScope;
};
export declare class InternalServiceProvider<E> {
    readonly _: ProviderContext<E>;
    constructor(services: IServiceCollection<E>, create: ProviderFactory<E>, validation: ProviderValidation, context: ProviderScope);
    getService<T>(nameSelector: NameSelector<T, E>): T;
    /**
     * Returns a new provider which stays within scope but resets validation
     */
    createScoped(): ServiceProvider<E>;
}
export declare type ServiceProvider<E> = Required<E> & InternalServiceProvider<E>;
