import { Keys } from './utils';
import { ServiceProvider } from './index';
export declare type Factory<T, E> = (provider: ServiceProvider<E>) => T;
export declare type ProviderValidation = {
    lastSingleton?: string;
    trail: Record<string, boolean>;
};
export declare type ProviderScope = Record<string, any>;
export declare type ProviderFactory<E> = (context?: ProviderScope) => ServiceProvider<E>;
export declare type DependencyConstructor<T, E> = {
    prototype: T;
    name: string;
    new (provider: ServiceProvider<E>): T;
} | {
    prototype: T;
    name: string;
    new (provider: Required<E>): T;
} | {
    prototype: T;
    name: string;
    new (): T;
};
export declare type NameSelector<T, E> = string | ((p: Keys<T, Required<E>>) => string);
